/* server test  */
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/wait.h>
#include <string.h>
#include <signal.h>
#include <errno.h>

pid_t	spid,cpid1,cpid2;

void endchild( int sig )
{
  char out[512];
  int res,status;
  int apid;

  apid=getpid();

  /* catch exit-codes from all ending childs */
  while ((res=waitpid(-1,&status,WNOHANG)) >0) {
     if (apid == spid ) {
           sprintf(out,"\nsigend1: Server=%d, waitpid successfull: PID: %d, Status: %d",apid,res,status>>8);
     } else {
           sprintf(out,"\n   sigend1: Client 1=%d, waitpid successfull: PID: %d, Status: %d",apid,res,status>>8);
     }
     write(2,out,strlen(out));
     }
     if (apid == spid ) {
              sprintf(out,"\nsigend2: Server=%d, waitpid failed: PID: %d, Status: %d",apid,res,status>>8);
     } else {
              sprintf(out,"\n   sigend2: Client 1=%d, waitpid failed: PID: %d, Status: %d",apid,res,status>>8);
     }
     write(2,out,strlen(out));

}

int main()
{
  char buffer[512];
  char out[512];
  int lgt,status,res;
  struct sigaction newsig,oldsig; /* signalhandling*/

  spid=getpid();
  sprintf(out,"\nServer (%d) startet",spid);
  write(2,out,strlen(out));
  /* init signalhandling  for catch end of process */
  newsig.sa_handler = endchild;
  sigemptyset(&newsig.sa_mask);
  newsig.sa_flags= 0;
  if (sigaction(SIGCHLD, &newsig, &oldsig) < 0) {
      sprintf(out,"\nServer can't catch SIGCHLD\n");
      write(2,out,strlen(out));
      exit(1);
  }

  for (;;) {
     write(1,"\n: ",3);
     if (( lgt=read(0,buffer,512)) <=0) {
        if ( errno == EINTR) {
           continue;
        }
        sprintf(out,"\nServer ended\n");
        write(2,out,strlen(out));
        exit(-1);
     }
     if (lgt <= 1) continue;
     if ( (cpid1 = fork()) < 0) {
          sprintf(out,"\nserver can't fork");
          write(2,out,strlen(out));
          exit(-2);
     }
     if (cpid1 == 0) {	
        /* child 1 */
        cpid1=getpid();
        sprintf(out,"\n   Client 1 (%d) start.",cpid1);
        write(2,out,strlen(out));
        if ( (cpid2 = fork()) < 0) {
             sprintf(out,"\n   Client 1 (%d) can't fork\n",cpid1);
             write(2,out,strlen(out));
             exit(-2);
        }
        if (cpid2 == 0 ) {
            /* child 2 */
            cpid2=getpid();
            sprintf(out,"\n      Client 2 (%d(%d)) start.\n",cpid2,cpid1);
            write(2,out,strlen(out));
            sleep(5);
            res='a'-buffer[0];
            sprintf(out,"\n      Client 2 (%d(%d)) end with %d.",cpid2,cpid1,res);
            write(2,out,strlen(out));
            exit(res);
        }
        /* child 1 nach fork */
        res=wait(&status);

        sprintf(out,"\n   Client 1 (%d) nach wait auf Client 2 (%d) PID: %d, Status: %d",cpid1,cpid2,res,status>>8);
        write(2,out,strlen(out));
        exit(status>>8);
       
     }  
     /* Server nach fork */
     sprintf(out,"\nServer (%d) start client 1 %d",spid,cpid1);
     write(2,out,strlen(out));
  }
  exit(0);
}
